#pragma semicolon 1

#include <cstrike>
#include <sourcemod>
#include <sdktools>
#include <ggdm>

public Plugin:myinfo = 
{
    name = "DeathMatch:SM Weapons Remover",
    author = GGDM_AUTHORS,
    description = "DeathMatch:SM Weapons Remover for SourceMod.",
    version = GGDM_VERSION,
    url = GGDM_URL
};

new g_WeaponParent;
new Handle:g_Cvar_RemoveWeapons         = INVALID_HANDLE;
new bool:g_removeWeapons;

public OnPluginStart()
{
    g_Cvar_RemoveWeapons = CreateConVar("sm_ggdm_removeweapons", "1", "Remove weapons");
    g_removeWeapons = GetConVarBool(g_Cvar_RemoveWeapons);
    
    HookConVarChange(g_Cvar_RemoveWeapons, CvarChanged);
    
    g_WeaponParent = FindSendPropOffs("CBaseCombatWeapon", "m_hOwnerEntity");

    StartHook();
}

StartHook() {
    HookEvent("player_death", Event_PlayerDeath);
    HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
}

StopHook() {
    UnhookEvent("player_death", Event_PlayerDeath);
    UnhookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
}

public CvarChanged(Handle:cvar, const String:oldValue[], const String:newValue[])
{
    if ( cvar == g_Cvar_RemoveWeapons )
    {
        g_removeWeapons = GetConVarBool(g_Cvar_RemoveWeapons);
        if ( g_removeWeapons ) {
            StartHook();
        } else {
            StopHook();
        }
        return;
    }
}

public Action:Event_RoundStart(Handle:event,const String:name[],bool:dontBroadcast)
{
    removeAllWeapons();
}

removeAllWeapons() {
    new maxent = GetMaxEntities(), String:weapon[64];
    for (new i = MaxClients; i < maxent; i++) {
        if ( IsValidEdict(i) && IsValidEntity(i) && GetEntDataEnt2(i, g_WeaponParent) == -1 ) {
            GetEdictClassname(i, weapon, sizeof(weapon));
            if ( ( StrContains(weapon, "weapon_") != -1 || StrContains(weapon, "item_") != -1 ) ) {
                RemoveEdict(i);
            }
        }
    }
}

public Action:Event_PlayerDeath(Handle:event,const String:name[],bool:dontBroadcast)
{
    removeAllWeapons();
}
